﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VTInlineFunctions
{
    public class VTCreditCard
    {
        public static bool IsCreditCardNumber(string creditCardNumber)
        {
            //// check whether input string is null or empty or spaces

            if (String.IsNullOrEmpty(creditCardNumber))
            {
                return false;
            }

            int sumOfDigits = 0;
            int index = 0;
            foreach (int digit in creditCardNumber.Where(e => e >= '0' && e <= '9').Reverse())
            {
                int temp = (index % 2 == 0) ? digit - 48 : (digit - 48) * 2;
                sumOfDigits += temp < 10 ? temp : temp - 9;
                index++;
            }
            return sumOfDigits % 10 == 0;
        }

        public static bool IsAmericanExpress(string creditCardNumber)
        {
            return IsCreditCardNumber(creditCardNumber) && VTRegex.DoesMatch(creditCardNumber, "^3[47][0-9]{13}$");
        }

        public static bool IsMasterCard(string creditCardNumber)
        {
            return IsCreditCardNumber(creditCardNumber) && VTRegex.DoesMatch(creditCardNumber, "^5[1-5][0-9]{14}$");
        }

        public static bool IsVISA(string creditCardNumber)
        {
            return IsCreditCardNumber(creditCardNumber) && VTRegex.DoesMatch(creditCardNumber, "^4[0-9]{12}(?:[0-9]{3})?$");
        }

        public static bool IsDinersClub(string creditCardNumber)
        {
            return IsCreditCardNumber(creditCardNumber) && VTRegex.DoesMatch(creditCardNumber, "^3(?:0[0-5]|[68][0-9])[0-9]{11}$ ");
        }

        public static bool IsDiscover(string creditCardNumber)
        {
            return IsCreditCardNumber(creditCardNumber) && VTRegex.DoesMatch(creditCardNumber, "^6(?:011|5[0-9]{2})[0-9]{12}$");
        }

        public static bool IsJCB(string creditCardNumber)
        {
            return IsCreditCardNumber(creditCardNumber) && VTRegex.DoesMatch(creditCardNumber, @"^(?:2131|1800|35\d{3})\d{11}$");
        }

    }
}
